#include <windows.h>
#include <GL/glut.h>
#include <stdio.h>
#include <crtdbg.h>
#include "resource.h"

//---]
float g_fTheta=0.0f;
//---EBhÊ߂̏
WNDPROC originalWndProc=NULL;	//̃EBhEvV[W
HWND g_hWnd=NULL;	//EBhEnh
HMENU g_hMenu=NULL;	//j[

//---

//̃vV[W
LRESULT CALLBACK overrideWndProc(HWND hWnd , UINT msg , WPARAM wParam , LPARAM lParam)
{
	switch (msg) {
	case WM_COMMAND:
		//j[R}h
		switch (LOWORD(wParam)){
		case ID_FILE_EXIT:
			PostQuitMessage(0);
		}
		return 0;
	case WM_DESTROY:
		//EBhEł̓vZXIȂ̂ŁAŋI
		exit(0);
		break;
	default:
		if(originalWndProc){
			return CallWindowProc(originalWndProc,hWnd , msg , wParam , lParam);
		}else{
			return DefWindowProc(hWnd,msg,wParam,lParam);
		}
	}
}

//ΏۃEBhĚ
BOOL CALLBACK enumWindowsProc(HWND hWnd,LPARAM lParam)
{
	HANDLE hModule=(HANDLE)GetWindowLong(hWnd,GWL_HINSTANCE);
	if(GetModuleHandle(NULL)==hModule){
		//̃vZXEBhE
		//--EBhENXr
		char szClassName[256];
		GetClassName(hWnd,szClassName,sizeof(szClassName)/sizeof(szClassName[0]));
		if(strncmp(szClassName,"GLUT",strlen(szClassName))==0){
			g_hWnd=hWnd;
			return FALSE;	//break
		}
	}
	return TRUE;	//continue
}

//EBhȄ
bool overrideGLWindow()
{
	EnumWindows(enumWindowsProc,0);
	if(g_hWnd){
		originalWndProc=(WNDPROC)GetWindowLong(g_hWnd,GWL_WNDPROC);
		SetWindowLong(g_hWnd,GWL_WNDPROC,(LONG)overrideWndProc);
		return true;
	}else{
		return false;
	}
}

//EBhEɃj[ݒ肷
bool setupMenu()
{
	g_hMenu=LoadMenu(GetModuleHandle(NULL),MAKEINTRESOURCE(IDR_MENU1));
	if(g_hMenu){
		SetMenu(g_hWnd,g_hMenu);
		return true;
	}else{
		return false;
	}
}

//---
//TCY
void OnResize(int w,int h)
{
	//EBhEŜr[|[gɂ
	glViewport(0, 0, w, h);
	//ϊs̏
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	gluPerspective(60.0f, ((GLfloat)w/h), 0.0001f, 200.0f);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void Idle()
{
	g_fTheta+=1.0f;
	glutPostRedisplay();
}

//fBXvC֐
void Display()
{
	//ʃNA
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(
		0.5f, 1.0f, 2.5f,
		0.0f, 0.0f, 0.0f,
		0.0f, 1.0f, 0.0f);

	glPushMatrix();
	{
		glRotatef(g_fTheta,0.5f,1.0f,0.0f);
		glutSolidTeapot(0.5f);
	}
	glPopMatrix();
	//o
	glutSwapBuffers();
}


//OpenGL̏
bool InitGL(int argc,char **argv)
{
	//GLUT
	glutInit(&argc, argv);

	//EBhE
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	glutInitWindowSize(800, 600);
	glutInitWindowPosition(100, 100);
	glutCreateWindow("OpenGL 3D Test Project");

	//EBhȄ
	if(!overrideGLWindow())return false;
	if(!setupMenu())return false;

	//EBhETCY
	// NCAg̈͏̈ꕔj[ɉBĂ܂߁A
	// j[̍␳Kv邩Ȃ
	OnResize(800,600);
	//--`ݒ
	glEnable(GL_DEPTH_TEST);

	//Light
	glEnable(GL_LIGHTING);

	float light_position[] = { 1.0f, -2.0f, 1.0f, 0.0f };
	float light_ambient[]={0.3f,0.3f,0.3f,1.0f};
	float light_diffuse[]={1.0f,1.0f,1.0f,1.0f};
	float light_specular[]={1.0f,1.0f,1.0f,1.0f};

	glLightfv( GL_LIGHT0, GL_POSITION, light_position );

	glLightfv( GL_LIGHT0, GL_AMBIENT, light_ambient );
	glLightfv( GL_LIGHT0, GL_DIFFUSE, light_diffuse );
	glLightfv( GL_LIGHT0, GL_SPECULAR, light_specular );

	glEnable(GL_LIGHT0);


	//e֐o^
	glutDisplayFunc(Display);
	glutReshapeFunc(OnResize);
	glutIdleFunc(Idle);
	//Fݒ
	glClearColor(0.5f, 0.5f, 0.5f, 1.0f);

	//@K
	glEnable(GL_NORMALIZE);

	return true;
}

// Program main
int main( int argc, char** argv)
{
#if defined(_DEBUG)
	// [Nop;̊JYꂪ΁AfobOo͂ɕ񍐂
	_CrtSetDbgFlag(
		_CRTDBG_ALLOC_MEM_DF
		| _CRTDBG_LEAK_CHECK_DF
		);
#endif

	//
	if(!InitGL(argc,argv))return 1;

	//C[v
	glutMainLoop();

	return 0;
}
